/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.ergebnis.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="SITZE.UK",
     query="SELECT o FROM Sitze o WHERE "

                         + "o"
                +".ergebnis"
                +".ergebnisart"
              +" = ?1"

             +" AND "         + "o"
                +".ergebnis"
                +".name"
              +" = ?2"

             +" AND "         + "o"
                +".ergebnis"
                +".wahl"
                +".wahlart"
                +".name"
              +" = ?3"

             +" AND "         + "o"
                +".ergebnis"
                +".wahl"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?4"

             +" AND "         + "o"
                +".ergebnis"
                +".wahl"
                +".wahltermin"
                +".nummer"
              +" = ?5"

             +" AND "         + "o"
                +".ergebnis"
                +".wahl"
                +".wahltermin"
                +".wahldatum"
              +" = ?6"

             +" AND "         + "o"
                +".ergebnis"
                +".wahl"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?7"

             +" AND "         + "o"
                +".gebiet"
                +".nummer"
              +" = ?8"

             +" AND "         + "o"
                +".gebiet"
                +".gebietsart"
                +".name"
              +" = ?9"

             +" AND "         + "o"
                +".gebiet"
                +".gebietsart"
                +".mandant"
                +".nummer"
              +" = ?10"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahlart"
                +".name"
              +" = ?11"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?12"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahltermin"
                +".nummer"
              +" = ?13"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahltermin"
                +".wahldatum"
              +" = ?14"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?15"

             +" AND "         + "o"
                +".gebiet"
                +".wahltermin"
                +".nummer"
              +" = ?16"

             +" AND "         + "o"
                +".gebiet"
                +".wahltermin"
                +".wahldatum"
              +" = ?17"

             +" AND "         + "o"
                +".gebiet"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?18"

             +" AND "         + "o"
                +".gruppe"
                +".schluessel"
              +" = ?19"

             +" AND "         + "o"
                +".gruppe"
                +".wahl"
                +".wahlart"
                +".name"
              +" = ?20"

             +" AND "         + "o"
                +".gruppe"
                +".wahl"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?21"

             +" AND "         + "o"
                +".gruppe"
                +".wahl"
                +".wahltermin"
                +".nummer"
              +" = ?22"

             +" AND "         + "o"
                +".gruppe"
                +".wahl"
                +".wahltermin"
                +".wahldatum"
              +" = ?23"

             +" AND "         + "o"
                +".gruppe"
                +".wahl"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?24"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="SITZE.ByErgebnis",
     query="DELETE FROM Sitze s where s.ergebnis = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="SITZE.CountErgebnis",
     query="SELECT COUNT(o) FROM Sitze o WHERE o.ergebnis=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="SITZE.CountSitzeByWahlAndErgebnisart",
     query="SELECT count(s) FROM Sitze s WHERE s.ergebnis.wahl = ?1 AND s.ergebnis.ergebnisart=?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="SITZE.Ergebnis",
     query="SELECT o FROM Sitze o WHERE o.ergebnis=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="SITZE.Gebiet",
     query="SELECT o FROM Sitze o WHERE o.gebiet = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="SITZE.GruppeGebietErgebnisartAndWahl",
     query="SELECT o FROM Sitze o WHERE o.gruppe =?1 AND o.gebiet=?2 AND o.ergebnis.ergebnisart=?3 AND o.ergebnis.wahl=?4",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="SITZE.GruppeImGebietAndErgebnisart",
     query="SELECT o FROM Sitze o WHERE o.gruppe =?1 AND o.gebiet=?2 AND o.ergebnis.ergebnisart=?3",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "SITZE")
// @javax.persistence.IdClass(SitzePK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Sitze
extends AbstractSitze
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor (protected, da mit CustomData aufgerufen werden muss)
   */
  protected Sitze() {
    super();
  }
    public Sitze(de.ivu.elect.jee.entity.customdata.CustomData customData){
                      if (customData != null && de.ivu.elect.jee.entity.customdata.EmptyCustomData.INSTANCE != customData) {
          customData.setTechnicalEntity(this);
          customDataStorage = new de.ivu.elect.business.customdata.entity.CustomDataStorage(customData);
        }
            }



    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Sitze(Sitze original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "sitze_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Sitze")
    @javax.persistence.TableGenerator(name = "Sitze", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Sitze", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient SitzePK pkCache;

  @Override
  public SitzePK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new SitzePK(getId());
    }

    return pkCache;
  }

  public static <E extends Sitze> java.util.Map<SitzePK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<SitzePK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Sitze> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;


  public void resetAttributeChanged() {
        hasChangedAnzahl = false;
          hasChangedAnzahlAnspruch = false;
  
      hasChangedCustomDataStorage = false;
        hasChangedErgebnis = false;
        hasChangedGebiet = false;
        hasChangedGruppe = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
      @javax.persistence.Column(name = "ANZAHL", nullable = SitzeConstants.ANZAHL_NULLABLE, precision=SitzeConstants.ANZAHL_PRECISION, scale=SitzeConstants.ANZAHL_SCALE)
            
  protected java.lang.Long anzahl =  null;

  @javax.persistence.Transient
  protected boolean hasChangedAnzahl = false;

  public boolean hasChangedAnzahl(){
    return hasChangedAnzahl;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertAnzahl = false;
     @javax.persistence.Transient
     private transient java.lang.Long wertNachLadenAnzahl;
  
  /**
   * 
   *
   * getter for SITZE.ANZAHL
   */
    @Override   public  java.lang.Long getAnzahl() {
        return anzahl;
      }

  /**
   * 
   *
   * setter for SITZE.ANZAHL
   *
   * @param anzahl
   */
  @Override   public void setAnzahl( java.lang.Long anzahl) {

       resetTkCache();
                  java.lang.Long anzahlInternal = anzahl;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.anzahl
      , anzahlInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedAnzahl |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("anzahl");
      }


             if (!isSeitLadenVeraendertAnzahl) {
          isSeitLadenVeraendertAnzahl = thisAttributChanged;
         if (isSeitLadenVeraendertAnzahl){
           wertNachLadenAnzahl=this.anzahl;
         }
       }
      

       this.anzahl = anzahlInternal;

         }

        
      @javax.persistence.Column(name = "ANZAHL_ANSPRUCH", nullable = SitzeConstants.ANZAHL_ANSPRUCH_NULLABLE, precision=SitzeConstants.ANZAHL_ANSPRUCH_PRECISION, scale=SitzeConstants.ANZAHL_ANSPRUCH_SCALE)
            
  protected java.lang.Long anzahlAnspruch =  null;

  @javax.persistence.Transient
  protected boolean hasChangedAnzahlAnspruch = false;

  public boolean hasChangedAnzahlAnspruch(){
    return hasChangedAnzahlAnspruch;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertAnzahlAnspruch = false;
     @javax.persistence.Transient
     private transient java.lang.Long wertNachLadenAnzahlAnspruch;
  
  /**
   * 
   *
   * getter for SITZE.ANZAHL_ANSPRUCH
   */
    @Override   public  java.lang.Long getAnzahlAnspruch() {
        return anzahlAnspruch;
      }

  /**
   * 
   *
   * setter for SITZE.ANZAHL_ANSPRUCH
   *
   * @param anzahlAnspruch
   */
  @Override   public void setAnzahlAnspruch( java.lang.Long anzahlAnspruch) {

       resetTkCache();
                  java.lang.Long anzahlAnspruchInternal = anzahlAnspruch;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.anzahlAnspruch
      , anzahlAnspruchInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedAnzahlAnspruch |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("anzahlAnspruch");
      }


             if (!isSeitLadenVeraendertAnzahlAnspruch) {
          isSeitLadenVeraendertAnzahlAnspruch = thisAttributChanged;
         if (isSeitLadenVeraendertAnzahlAnspruch){
           wertNachLadenAnzahlAnspruch=this.anzahlAnspruch;
         }
       }
      

       this.anzahlAnspruch = anzahlAnspruchInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu CustomDataStorage
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "CUSTOM_DATA_STORAGE_ID", referencedColumnName="CUSTOM_DATA_STORAGE_ID"))
  protected de.ivu.elect.business.customdata.entity.CustomDataStorage customDataStorage;

  /**
   * 
   */
  @Override
  public void setCustomDataStorage(@javax.annotation.Nullable  de.ivu.elect.business.customdata.entity.CustomDataStorage customDataStorage){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.customDataStorage
    , customDataStorage);

    attributeChanged |= thisAttributChanged;

    hasChangedCustomDataStorage |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("customDataStorage");
    }

    this.customDataStorage = customDataStorage;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.customdata.entity.CustomDataStorage getCustomDataStorage(){
    return this.customDataStorage;
  }

  @javax.persistence.Transient
  protected boolean hasChangedCustomDataStorage = false;

  public boolean hasChangedCustomDataStorage(){
    return hasChangedCustomDataStorage;
  }

  /**
   * Beziehung (unidirektional) zu Ergebnis
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "ERGEBNIS_ID", referencedColumnName="ERGEBNIS_ID"))
  protected de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis;

  /**
   * 
   */
  @Override
  public void setErgebnis( de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ergebnis
    , ergebnis);

    attributeChanged |= thisAttributChanged;

    hasChangedErgebnis |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("ergebnis");
    }

    this.ergebnis = ergebnis;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.ergebnis.entity.Ergebnis getErgebnis(){
    return this.ergebnis;
  }

  @javax.persistence.Transient
  protected boolean hasChangedErgebnis = false;

  public boolean hasChangedErgebnis(){
    return hasChangedErgebnis;
  }

  /**
   * Beziehung (unidirektional) zu Gebiet
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "GEBIET_ID", referencedColumnName="GEBIET_ID"))
  protected de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet;

  /**
   * 
   */
  @Override
  public void setGebiet( de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.gebiet
    , gebiet);

    attributeChanged |= thisAttributChanged;

    hasChangedGebiet |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("gebiet");
    }

    this.gebiet = gebiet;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.gebietsbaum.entity.Gebiet getGebiet(){
    return this.gebiet;
  }

  @javax.persistence.Transient
  protected boolean hasChangedGebiet = false;

  public boolean hasChangedGebiet(){
    return hasChangedGebiet;
  }

  /**
   * Beziehung (unidirektional) zu Gruppe
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "GRUPPE_ID", referencedColumnName="GRUPPE_ID"))
  protected de.ivu.elect.business.gruppe.entity.Gruppe gruppe;

  /**
   * 
   */
  @Override
  public void setGruppe( de.ivu.elect.business.gruppe.entity.Gruppe gruppe){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.gruppe
    , gruppe);

    attributeChanged |= thisAttributChanged;

    hasChangedGruppe |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("gruppe");
    }

    this.gruppe = gruppe;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.gruppe.entity.Gruppe getGruppe(){
    return this.gruppe;
  }

  @javax.persistence.Transient
  protected boolean hasChangedGruppe = false;

  public boolean hasChangedGruppe(){
    return hasChangedGruppe;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Sitze:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Sitze other){
                             other.anzahl = this.anzahl;
                                other.anzahlAnspruch = this.anzahlAnspruch;
           
  other.setCustomDataStorage(this.getCustomDataStorage());
  other.setErgebnis(this.getErgebnis());
  other.setGebiet(this.getGebiet());
  other.setGruppe(this.getGruppe());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Sitze.class)){
        copyEntityAttributesUsingSetter((Sitze) other.castTo(Sitze.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Sitze: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Sitze other){
               other.setAnzahl(this.anzahl);
                  other.setAnzahlAnspruch(this.anzahlAnspruch);
           other.setCustomDataXml(this.getCustomDataXml());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Sitze other){
                       if (hasChangedAnzahl) {
        other.setAnzahl(this.anzahl);
      }
                             if (hasChangedAnzahlAnspruch) {
        other.setAnzahlAnspruch(this.anzahlAnspruch);
      }
             }




    /**
    * Hat die Entität überhaupt einen CustomDataStorage?
    */
    private boolean isCustomDataSupported() {
      return getCustomDataStorage()!=null;
    }

    @Override
    public de.ivu.elect.jee.entity.customdata.CustomData getCustomData() {
      if (isCustomDataSupported()) {
        de.ivu.elect.jee.entity.customdata.CustomData result = getCustomDataStorage().getCustomData();
        result.setTechnicalEntity(this); // Fachliche Entität bei jedem Zugriff setzen
        return result;
      }
      return de.ivu.elect.jee.entity.customdata.EmptyCustomData.INSTANCE;
    }


    @Override
    @SuppressWarnings("unchecked")
    public <T extends de.ivu.elect.jee.entity.customdata.CustomData> T getCustomData(Class<T> clazz) {
      if (isCustomDataSupported()) {
        return (T) getCustomData();
      }
      throw new IllegalStateException("Entität Sitze besitzt kein CustomDataStorage: "+this);
    }


    @Override
    public void updateCustomData() {
      if (isCustomDataSupported()) {
        getCustomDataStorage().updateCustomData();
      }
    }


    public void clearCustomDataCache() {
      if (isCustomDataSupported()) {
        getCustomDataStorage().clearCustomDataCache();
      }
    }

    @Override
    public String getCustomDataXml(){
      if (isCustomDataSupported()) {
        return getCustomDataStorage().getCustomDataXml();
      }
      return "";
    }

    @Override
    public void setCustomDataXml(String customDataXml){
      if (isCustomDataSupported()) {
        if (org.apache.commons.lang3.StringUtils.isBlank(customDataXml)) {
          if (de.ivu.elect.business.system.control.FailOnUnkownCustomData.FAIL_ON_UNKNOWN_CUSTOM_DATA) {
            throw new IllegalStateException("Entität Sitze hat CustomDataStorage, soll aber kein CustomData aufnehmen: '"+customDataXml+"'");
          }
          // ELECTMUC-2581
          System.err.println("Entität Sitze hat CustomDataStorage, soll aber kein CustomData aufnehmen: '"+customDataXml+"'");
        } else {
          getCustomDataStorage().setCustomDataXml(customDataXml);
        }
        clearCustomDataCache(); // WASDE-1131
      } else {
       if (org.apache.commons.lang3.StringUtils.isNotBlank(customDataXml)) {
         if (customDataXml.endsWith("EmptyCustomData/>")) {
            // Abwärtskompatibilität...alles gut, die alten, leeren CustomDataObjekte...
         } else {
           if (de.ivu.elect.business.system.control.FailOnUnkownCustomData.FAIL_ON_UNKNOWN_CUSTOM_DATA) {
             throw new IllegalStateException("Entität Sitze hat kein CustomDataStorage, soll aber CustomData aufnehmen: '"+customDataXml+"'");
           }
           // ELECT-5122
           System.err.println("Entität Sitze hat kein CustomDataStorage, soll aber CustomData aufnehmen: '"+customDataXml+"'");
         }
       }
      }
    }

    public boolean hasChangedCustomDataXml() {
      if (isCustomDataSupported()) {
        return getCustomDataStorage().hasChangedCustomDataXml();
      }
      return false;
    }


    @javax.persistence.Transient
    private transient SitzeTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public SitzeTK getSitzeTK(){
    if (tkCache==null) {
    tkCache = new SitzeTK(

  (getGebiet() == null) ? null : getGebiet().getGebietTK()
,   (getGruppe() == null) ? null : getGruppe().getGruppeTK()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getSitzeTK();
    }

  @Override
  public SitzeUK getUk(){
    return getSitzeUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Sitze.class;
  }

public SitzeUK getSitzeUK(){

   return  new SitzeUK(

    getErgebnis()==null?null:getErgebnis().getErgebnisUK()
,     getGebiet()==null?null:getGebiet().getGebietUK()
,     getGruppe()==null?null:getGruppe().getGruppeUK()


  );
}

  @javax.persistence.Transient
  private transient SitzeProperties properties;

  public SitzeProperties getProperties(){
    if (properties == null) {
      properties = new SitzeProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public SitzeProperties getSitzeProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return SitzeConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(SitzeConstants.MESSAGE_KEY_ANZAHL_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(SitzeConstants.MESSAGE_KEY_ANZAHL_EINZAHL);

        anzahl =
                        vorher.getAttributTyp().getValueAsLong(vorher.getWertVorher());
                  }

            
      if (werteVorher.containsKey(SitzeConstants.MESSAGE_KEY_ANZAHL_ANSPRUCH_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(SitzeConstants.MESSAGE_KEY_ANZAHL_ANSPRUCH_EINZAHL);

        anzahlAnspruch =
                        vorher.getAttributTyp().getValueAsLong(vorher.getWertVorher());
                  }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertAnzahl) {
      result.put(SitzeConstants.MESSAGE_KEY_ANZAHL_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.LONG
                            , wertNachLadenAnzahl , anzahl));
    }
                            if (isSeitLadenVeraendertAnzahlAnspruch) {
      result.put(SitzeConstants.MESSAGE_KEY_ANZAHL_ANSPRUCH_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.LONG
                            , wertNachLadenAnzahlAnspruch , anzahlAnspruch));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertAnzahl = false;
      wertNachLadenAnzahl = null;
                          isSeitLadenVeraendertAnzahlAnspruch = false;
      wertNachLadenAnzahlAnspruch = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                                            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "SITZE";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Sitze";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

  @javax.persistence.Transient
  private transient boolean hashCodeBerechnet = false;

  @javax.persistence.Transient
  private transient int hashCode = 0;


  @Deprecated // nur in Unit-Tests verwenden(!)
  public void resetHashCode() {
    hashCodeBerechnet = false;
    hashCode = 0;
  }

  @Override
    public int hashCode() {
      if (hashCodeBerechnet) {
      return hashCode;
    }

    if (id == null) {
      hashCode = super.hashCode();
    } else {
      hashCode = id.hashCode();
    }

    hashCodeBerechnet = true;

    return hashCode;

    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(anzahl, this, SitzeConstants.MESSAGE_KEY_ANZAHL_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(SitzeConstants.ANZAHL_MAX_VALUE, SitzeConstants.ANZAHL_MIN_VALUE, anzahl, this, SitzeConstants.MESSAGE_KEY_ANZAHL_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(anzahlAnspruch, this, SitzeConstants.MESSAGE_KEY_ANZAHL_ANSPRUCH_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(SitzeConstants.ANZAHL_ANSPRUCH_MAX_VALUE, SitzeConstants.ANZAHL_ANSPRUCH_MIN_VALUE, anzahlAnspruch, this, SitzeConstants.MESSAGE_KEY_ANZAHL_ANSPRUCH_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        @Override
        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }
                              }
